(*
       ********************************************
               Execute only out of Delphi
       ********************************************
       After expired per numberexecutions you call
       Protect.ClearNumberExecutions;
*)


unit DemoMain;

interface

uses
  Classes, Controls, Forms, Dialogs, StdCtrls, sysutils, 
  bfs_protecs;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;
    Protect: TBFSProtect;
    procedure ProtectProtecting(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ProtectRunCDRomDisk(Sender: TObject);
    procedure ProtectRunFixedDisk(Sender: TObject);
    procedure ProtectRunRamDisk(Sender: TObject);
    procedure ProtectRunRemoteDisk(Sender: TObject);
    procedure ProtectRunRemovableDisk(Sender: TObject);
    procedure ProtectDateExpired(Sender: TObject);
    procedure ProtectMaxExecutionsExpired(Sender: TObject);
    procedure ProtectDaysExpired(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ProtectProtecting(Sender: TObject);
var Msg : string;
const S = 'Illegal copy'#13;
      D = 'drive installed is other'#13;
      P = 'executly out of directory of install!';
      F = #13#13'Terminate now!';
begin
if not Protect.AutoProtect then
begin
 if poSerial in Protect.ProtectOptions then
 Msg := Msg + S;
 if poDrive in Protect.ProtectOptions then
 Msg := Msg + 'or ' + D;
 if poPath in Protect.ProtectOptions then
 Msg := Msg + 'or ' + P;
                     
 MessageDlg(Msg+F,mtWarning,[mbOk],0);
 Application.Terminate;
 end;           
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
//  Protect.ClearNumberExecutions; //use to clear numberexecutions from registry
 if not Protect.AutoProtect then
 Protect.ToProtect;

 Label1.Caption := 'Number executions: '+IntToStr(Protect.NumberExecutions);
 Label2.Caption := 'Executions remaining: '+IntToStr(Protect.MaxExecutions - Protect.NumberExecutions);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 Application.Terminate;
end;

const M = 'This program execute only in ';

procedure TForm1.ProtectRunCDRomDisk(Sender: TObject);
begin
 MessageDlg(M+'CdRom!',mtError,[mbOk],0);
end;

procedure TForm1.ProtectRunFixedDisk(Sender: TObject);
begin
  MessageDlg(M+'HD!',mtError,[mbOk],0);
end;

procedure TForm1.ProtectRunRamDisk(Sender: TObject);
begin
 MessageDlg(M+'Ram Disk!',mtError,[mbOk],0);
end;

procedure TForm1.ProtectRunRemoteDisk(Sender: TObject);
begin
  MessageDlg(M+'Remote Disk!',mtError,[mbOk],0);
end;

procedure TForm1.ProtectRunRemovableDisk(Sender: TObject);
begin
  MessageDlg(M+'Removable Disk!',mtError,[mbOk],0);
end;

procedure TForm1.ProtectDateExpired(Sender: TObject);
begin
   MessageDlg('Avaliable time expired for this version !',mtInformation,[mbOk],0);
   Application.terminate;
end;

procedure TForm1.ProtectMaxExecutionsExpired(Sender: TObject);
begin
    MessageDlg('Number max of executions exceed!',mtInformation,[mbOk],0);
    Application.Terminate;           
end;

procedure TForm1.ProtectDaysExpired(Sender: TObject);
begin
    MessageDlg('Avaliable time expired for this version !',mtInformation,[mbOk],0);
   Application.terminate;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Protect.ClearNumberExecutions;

 Label2.Caption := 'Executions remaining: '+IntToStr(Protect.MaxExecutions - Protect.NumberExecutions);
end;

end.
